function IFT = build_inverted_file( codebook )

% list of precomputed sift features for each image
d = dir('*_sift.mat');
num_ims = length(d);

N = size(codebook,1);

% inverted file table
IFT = zeros(N,num_ims);

%% 

for i=1:num_ims,
   % load the sift features 
   load(d(i).name); 

   descr = single(descr');
   
   % quantize them onto the dictionary
   for j=1:size(descr,1),

        dists = calcdist(codebook,descr(j,:));
        [y,k] = min(dists);
        IFT(k,i) = IFT(k,i) + 1;

    end
   
   % mark the appropriate rows in the table
    
end