% compute sift features
function compute_sift_features()

%%
d = dir('*.jpg');

for i=1:length(d),
   display(i);
   % read image (and convert to grayscale)
   im = imreadbw(d(i).name);
   
   % contrast normalize (to [0,1])
   im=im-min(im(:));
   im=im/max(im(:));
    
   
   % compute sift
   [frames, descr] = sift( im );
   
   % scale to integer
   descr=uint8(512*descr) ;
   
   % save to file
   filename = [d(i).name(1:end-3) 'mat'];
   
   save(filename,'descr','frames');
   
end