%% investigate matches
function local_search_gui( data_dir )
%%

if ~exist('data_dir','var') || isempty(data_dir)    
    data_dir = '../../Data/party pics/';
end

d = dir([data_dir '*.jpg']);
s = dir([data_dir '*_sift.mat']);
num_ims = length(d);

W = min(num_ims,15);

%%
%im_thumbs = cell(num_ims,1);

%% load thumbnails

tile_im = zeros(100*ceil(num_ims/W) , 100 * W,3);

for i=1:num_ims,
    
    thm = imread([data_dir d(i).name]);
    thm = imresize(thm,[100 100],'bilinear');
    x = mod(i-1,W)+1;
    y = ceil(i/W);
    tile_im((y-1)*100 + 1: y*100, (x-1)*100 + 1: x*100, :) = im2double(thm);
    %subplot(ceil(num_ims/10),10,i);
    %imshow(im_thumbs{i});
end
%%
% plot thumbnails
figure(1);
imshow(tile_im);

B1 = 0;
B2 = 0;

while 1
    
    figure(1);
    [x,y,b] = ginput(1);
    
    x = max(min(ceil(x/100),W),1);
    y = max(ceil(y/100),1);
    ind = (y-1)*W + x;
    
    if ind > num_ims
        continue;
    end

    
    if b == 1
        B1 = ind;        
    elseif b == 3
        B2 = ind;        
    elseif b == 'q'
        break;
    else
        continue;
    end
    

    imshow(tile_im);
    hold on;
    if B1 > 0
        plot_box(B1,W,'r');
        
        load([data_dir s(B1).name]);
        B1_descr = descr;
        B1_frames= frames;
        
        B1_im = im2double(imread([data_dir d(B1).name]));
    end
    
    if B2 > 0
        plot_box(B2,W,'g--');
        
        load([data_dir s(B2).name]);
        B2_descr = descr;
        B2_frames= frames;
        B2_im = im2double(imread([data_dir d(B2).name]));
    end
    
    
    % do sift matching
    if B1 > 0 && B2 > 0

        matches = siftmatch(B1_descr, B2_descr);
        
        figure(2);
        plotmatches(B1_im, B2_im, B1_frames,B2_frames,matches,'Interactive',2);
    end
end


%%
function plot_box( ind, W, c)
    x = mod(ind-1,W)+1;
    y = ceil(ind/W);
    plot([(x-1)*100+1 (x-1)*100+1 (x)*100 (x)*100 (x-1)*100+1], [(y-1)*100+1  y*100 y*100 (y-1)*100+1 (y-1)*100+1], c,'LineWidth',2);

        